package com.maintainj.android.trace.manager;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;

import android.app.Activity;
import android.os.Bundle;
import android.os.Environment;
import android.test.sdcard.R;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class TraceManagerActivity extends Activity {	
	private Button btnTraceController;
	private EditText textTraceFileName; 

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		final File path = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS);
		path.mkdirs();		                
        
		setContentView(R.layout.main);
		

		btnTraceController = (Button) findViewById(R.id.btnTraceController);
		textTraceFileName = (EditText)findViewById(R.id.txtTraceFileName);
		
		btnTraceController.setOnClickListener(new OnClickListener() {
			
			private boolean started = true;
			
			public void onClick(View v) {
				try {
					File myFile = new File(path, "MaintainJTraceController.txt");
					myFile.createNewFile();
				
					Log.v("TraceController", "TraceController file name:" + myFile.getAbsolutePath());
									
					BufferedWriter myOutWriter = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(myFile)));
					if(started){
						String traceFileName = textTraceFileName.getEditableText().toString();
						myOutWriter.write("stop");
						myOutWriter.newLine();
						myOutWriter.write(traceFileName);
					} else {
						myOutWriter.write("start");
						
					}					
					myOutWriter.close();
					
					if(started){
						String message = "Stopped tracing. The trace files are placed in sdcard/Download folder.";					
						Toast.makeText(getBaseContext(), message, Toast.LENGTH_LONG).show();
					} else {
						Toast.makeText(getBaseContext(), "Started tracing", Toast.LENGTH_LONG).show();
					}
					
					btnTraceController.setText(started ? "Start Tracing" : "Stop Tracing");
					
					started = !started;
				} catch (Exception e) {
					Log.e("TraceController", "TraceController Exception:" + e.getMessage());
					Toast.makeText(getBaseContext(), e.getMessage()+"--File:",
							Toast.LENGTH_LONG).show();
				}
			}
		}); 
	}
}